/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.Keys;
import de.ship.db.tables.TCoreVariable.TCoreVariablePath;
import de.ship.db.tables.records.TDmVarAddRecord;

import java.time.LocalDateTime;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class TDmVarAdd extends TableImpl<TDmVarAddRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.t_dm_var_add</code>
     */
    public static final TDmVarAdd T_DM_VAR_ADD = new TDmVarAdd();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TDmVarAddRecord> getRecordType() {
        return TDmVarAddRecord.class;
    }

    /**
     * The column <code>common_dd.t_dm_var_add.lastchange</code>.
     */
    public final TableField<TDmVarAddRecord, LocalDateTime> LASTCHANGE = createField(DSL.name("lastchange"), SQLDataType.LOCALDATETIME(6).defaultValue(DSL.field(DSL.raw("now()"), SQLDataType.LOCALDATETIME)), this, "");

    /**
     * The column <code>common_dd.t_dm_var_add.pk</code>.
     */
    public final TableField<TDmVarAddRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>common_dd.t_dm_var_add.fk_variable</code>. ID of
     * variable
     */
    public final TableField<TDmVarAddRecord, Integer> FK_VARIABLE = createField(DSL.name("fk_variable"), SQLDataType.INTEGER.nullable(false), this, "ID of variable");

    /**
     * The column <code>common_dd.t_dm_var_add.fk_tabledef</code>. variable
     * reference (key_variable) for this adding
     */
    public final TableField<TDmVarAddRecord, Integer> FK_TABLEDEF = createField(DSL.name("fk_tabledef"), SQLDataType.INTEGER.nullable(false), this, "variable reference (key_variable) for this adding");

    private TDmVarAdd(Name alias, Table<TDmVarAddRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TDmVarAdd(Name alias, Table<TDmVarAddRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_var_add</code> table reference
     */
    public TDmVarAdd(String alias) {
        this(DSL.name(alias), T_DM_VAR_ADD);
    }

    /**
     * Create an aliased <code>common_dd.t_dm_var_add</code> table reference
     */
    public TDmVarAdd(Name alias) {
        this(alias, T_DM_VAR_ADD);
    }

    /**
     * Create a <code>common_dd.t_dm_var_add</code> table reference
     */
    public TDmVarAdd() {
        this(DSL.name("t_dm_var_add"), null);
    }

    public <O extends Record> TDmVarAdd(Table<O> path, ForeignKey<O, TDmVarAddRecord> childPath, InverseForeignKey<O, TDmVarAddRecord> parentPath) {
        super(path, childPath, parentPath, T_DM_VAR_ADD);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TDmVarAddPath extends TDmVarAdd implements Path<TDmVarAddRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TDmVarAddPath(Table<O> path, ForeignKey<O, TDmVarAddRecord> childPath, InverseForeignKey<O, TDmVarAddRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TDmVarAddPath(Name alias, Table<TDmVarAddRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TDmVarAddPath as(String alias) {
            return new TDmVarAddPath(DSL.name(alias), this);
        }

        @Override
        public TDmVarAddPath as(Name alias) {
            return new TDmVarAddPath(alias, this);
        }

        @Override
        public TDmVarAddPath as(Table<?> alias) {
            return new TDmVarAddPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public Identity<TDmVarAddRecord, Integer> getIdentity() {
        return (Identity<TDmVarAddRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TDmVarAddRecord> getPrimaryKey() {
        return Keys.PK_DM_VAR_ADD;
    }

    @Override
    public List<ForeignKey<TDmVarAddRecord, ?>> getReferences() {
        return Arrays.asList(Keys.T_DM_VAR_ADD__FK_VARIABLE_VAR_ADD);
    }

    private transient TCoreVariablePath _tCoreVariable;

    /**
     * Get the implicit join path to the <code>common_dd.t_core_variable</code>
     * table.
     */
    public TCoreVariablePath tCoreVariable() {
        if (_tCoreVariable == null)
            _tCoreVariable = new TCoreVariablePath(this, Keys.T_DM_VAR_ADD__FK_VARIABLE_VAR_ADD, null);

        return _tCoreVariable;
    }

    @Override
    public TDmVarAdd as(String alias) {
        return new TDmVarAdd(DSL.name(alias), this);
    }

    @Override
    public TDmVarAdd as(Name alias) {
        return new TDmVarAdd(alias, this);
    }

    @Override
    public TDmVarAdd as(Table<?> alias) {
        return new TDmVarAdd(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmVarAdd rename(String name) {
        return new TDmVarAdd(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmVarAdd rename(Name name) {
        return new TDmVarAdd(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TDmVarAdd rename(Table<?> name) {
        return new TDmVarAdd(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmVarAdd where(Condition condition) {
        return new TDmVarAdd(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmVarAdd where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmVarAdd where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmVarAdd where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmVarAdd where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmVarAdd where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmVarAdd where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TDmVarAdd where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmVarAdd whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TDmVarAdd whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
